XTS_Final< CIPHER > Class Template Reference

XTS block cipher mode of operation implementation. More...

`#include <xts.h>`

Inheritance diagram for XTS_Final< CIPHER >:

## Additional Inherited Members

Public Types inherited from SimpleKeyingInterface
enum | IV_Requirement { UNIQUE_IV = 0 , RANDOM_IV , UNPREDICTABLE_RANDOM_IV , INTERNALLY_GENERATED_IV , NOT_RESYNCHRONIZABLE }
| Secure IVs requirements as enumerated values. More...
Public Member Functions inherited from XTS_ModeBase
std::string | AlgorithmName () const
| Provides the name of this algorithm.
std::string | AlgorithmProvider () const
| Retrieve the provider of this algorithm.
size_t | MinKeyLength () const
| Returns smallest valid key length.
size_t | MaxKeyLength () const
| Returns largest valid key length.
size_t | DefaultKeyLength () const
| Returns default key length.
size_t | GetValidKeyLength (size_t n) const
| Returns a valid key length for the algorithm.
bool | IsValidKeyLength (size_t keylength) const
| Returns whether keylength is a valid key length.
void | ThrowIfInvalidKeyLength (size_t length)
| Validates the key length.
unsigned int | BlockSize () const
| Provides the block size of the cipher.
unsigned int | GetOptimalBlockSize () const
| Provides the input block size most efficient for this cipher.
unsigned int | MinLastBlockSize () const
| Provides the size of the last block.
unsigned int | OptimalDataAlignment () const
| Provides input and output data alignment for optimal performance.
void | ThrowIfInvalidBlockSize (size_t length)
| Validates the block size.
void | SetKey (const byte *key, size_t length, const NameValuePairs &params=g_nullNameValuePairs)
| Sets or reset the key of this object.
IV_Requirement | IVRequirement () const
| Minimal requirement for secure IVs.
void | Resynchronize (const byte *iv, int ivLength=-1)
| Resynchronize with an IV.
void | ProcessData (byte *outString, const byte *inString, size_t length)
| Encrypt or decrypt an array of bytes.
size_t | ProcessLastBlock (byte *outString, size_t outLength, const byte *inString, size_t inLength)
| Encrypt or decrypt the last block of data.
void | Resynchronize (word64 sector, ByteOrder order=BIG_ENDIAN_ORDER)
| Resynchronize the cipher.
Public Member Functions inherited from BlockOrientedCipherModeBase
void | UncheckedSetKey (const byte *key, unsigned int length, const NameValuePairs &params)
| Sets the key for this object without performing parameter validation.
unsigned int | MandatoryBlockSize () const
| Provides the mandatory block size of the cipher.
bool | IsRandomAccess () const
| Determines whether the cipher supports random access.
bool | IsSelfInverting () const
| Determines whether the cipher is self-inverting.
bool | IsForwardTransformation () const
| Determines if the cipher is being operated in its forward direction.
Public Member Functions inherited from CipherModeBase
unsigned int | IVSize () const
| Returns length of the IV accepted by this object.
void | SetCipher (BlockCipher &cipher)
| Set external block cipher.
void | SetCipherWithIV (BlockCipher &cipher, const byte *iv, int feedbackSize=0)
| Set external block cipher and IV.
Public Member Functions inherited from SimpleKeyingInterface
void | SetKeyWithRounds (const byte *key, size_t length, int rounds)
| Sets or reset the key of this object.
void | SetKeyWithIV (const byte *key, size_t length, const byte *iv, size_t ivLength)
| Sets or reset the key of this object.
void | SetKeyWithIV (const byte *key, size_t length, const byte *iv)
| Sets or reset the key of this object.
bool | IsResynchronizable () const
| Determines if the object can be resynchronized.
bool | CanUseRandomIVs () const
| Determines if the object can use random IVs.
bool | CanUsePredictableIVs () const
| Determines if the object can use random but possibly predictable IVs.
bool | CanUseStructuredIVs () const
| Determines if the object can use structured IVs.
unsigned int | DefaultIVLength () const
| Provides the default size of an IV.
virtual unsigned int | MinIVLength () const
| Provides the minimum size of an IV.
virtual unsigned int | MaxIVLength () const
| Provides the maximum size of an IV.
virtual void | GetNextIV (RandomNumberGenerator &rng, byte *iv)
| Retrieves a secure IV for the next message.
Public Member Functions inherited from StreamTransformation
StreamTransformation & | Ref ()
| Provides a reference to this object.
virtual unsigned int | OptimalBlockSize () const
| Provides the input block size most efficient for this cipher.
virtual unsigned int | GetOptimalBlockSizeUsed () const
| Provides the number of bytes used in the current block when processing at optimal block size.
virtual bool | IsLastBlockSpecial () const
| Determines if the last block receives special processing.
void | ProcessString (byte *inoutString, size_t length)
| Encrypt or decrypt a string of bytes.
void | ProcessString (byte *outString, const byte *inString, size_t length)
| Encrypt or decrypt a string of bytes.
byte | ProcessByte (byte input)
| Encrypt or decrypt a byte.
virtual void | Seek (lword pos)
| Seek to an absolute position.
Public Member Functions inherited from Algorithm
| Algorithm (bool checkSelfTestStatus=true)
| Interface for all crypto algorithms.
Public Member Functions inherited from Clonable
virtual Clonable * | Clone () const
| Copies this object.
Static Public Member Functions inherited from XTS_ModeBase
static const char * | StaticAlgorithmName ()
| The algorithm name.

## Detailed Description

template<class CIPHER>
class XTS_Final< CIPHER >

XTS block cipher mode of operation implementation.

Template Parameters

  CIPHER | BlockCipher derived class or type

XTS_Final() provides access to CIPHER in base class XTS_ModeBase() through an interface. AccessBlockCipher() and AccessTweakCipher() allow the XTS_ModeBase() base class to access the user's block cipher without recompiling the library.

If `CRYPTOPP_XTS_WIDE_BLOCK_CIPHERS` is 0, then CIPHER must be a 16-byte block cipher. If `CRYPTOPP_XTS_WIDE_BLOCK_CIPHERS` is non-zero then CIPHER can be 16, 32, 64, or 128-byte block cipher. There is risk involved with using XTS with wider block ciphers. According to Phillip Rogaway, "The narrow width of the underlying PRP and the poor treatment of fractional final blocks are problems." To enable wide block cipher support define `CRYPTOPP_XTS_WIDE_BLOCK_CIPHERS` to non-zero.

See also
  Modes of Operation on the Crypto++ wiki, Evaluation of Some Blockcipher Modes of Operation, Recommendation for Block Cipher Modes of Operation: The XTS-AES Mode for Confidentiality on Storage Devices, IEEE P1619-2007 and IEEE P1619/XTS, inconsistent reference implementation and test vectors.

Since
  Crypto++ 8.3

Definition at line 175 of file xts.h.

The documentation for this class was generated from the following file:

- xts.h